(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     12638,        306]
NotebookOptionsPosition[     12141,        284]
NotebookOutlinePosition[     12475,        299]
CellTagsIndexPosition[     12432,        296]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"yhProgram", "=", 
   RowBox[{"NotebookOpen", "[", 
    RowBox[{
     RowBox[{"Directory", "[", "]"}], "<>", 
     "\"\</YH-classical-20150501.nb\>\""}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SelectionMove", "[", 
   RowBox[{"yhProgram", ",", "All", ",", "Notebook"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SelectionEvaluate", "[", "yhProgram", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ToWord", "[", "indices_", "]"}], ":=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       SubscriptBox["g", 
        RowBox[{"Abs", "[", "#", "]"}]], "^", 
       RowBox[{"Sign", "[", "#", "]"}]}], "&"}], ",", "indices"}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.634811062728961*^9, 3.634811063462975*^9}, 
   3.6348172895382357`*^9, {3.63481732526128*^9, 3.6348173720330057`*^9}, {
   3.634817414196745*^9, 3.634817443322084*^9}, 3.6348214936490016`*^9, {
   3.639388849628593*^9, 3.639388851257346*^9}, {3.639421451432016*^9, 
   3.6394214532617064`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"min", "=", "154"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"max", "=", "179"}], ";", 
  RowBox[{"(*", 
   RowBox[{"179", ";"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"step", "=", "8"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"kernels", "=", "8"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"filename", " ", "=", " ", "\"\<links-different.csv\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"stream", "=", 
   RowBox[{"OpenWrite", "[", "filename", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "stream", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"streamT", "=", 
   RowBox[{"OpenWrite", "[", "\"\<time.csv\>\"", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Close", "[", "streamT", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CloseKernels", "[", "]"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"For", "[", 
  RowBox[{
   RowBox[{"i", "=", "0"}], ",", 
   RowBox[{
    RowBox[{"min", "+", 
     RowBox[{"i", "*", "step"}], "-", "1"}], "<", "max"}], ",", 
   RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"from", "=", 
     RowBox[{"min", "+", 
      RowBox[{"i", "*", "step"}]}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"to", "=", " ", 
     RowBox[{"Min", "[", 
      RowBox[{
       RowBox[{"min", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"i", "+", "1"}], ")"}], "*", "step"}], " ", "-", "1"}], ",",
        "max"}], "]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"data", "=", 
     RowBox[{"Import", "[", 
      RowBox[{"\"\<linkinfo_same_Homflypt.xlsx\>\"", ",", 
       RowBox[{"{", 
        RowBox[{"\"\<Data\>\"", ",", "3", ",", 
         RowBox[{"Range", "[", 
          RowBox[{"from", ",", "to"}], "]"}]}], "}"}]}], "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"onlyOne", "=", 
     RowBox[{"(", 
      RowBox[{"from", "\[Equal]", "to"}], ")"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"If", "[", 
     RowBox[{"onlyOne", ",", 
      RowBox[{"data", "=", 
       RowBox[{"{", "data", "}"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
    RowBox[{"knots", " ", "=", 
     RowBox[{"ToString", " ", "/@", " ", 
      RowBox[{"data", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "1"}], "]"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"words", "=", 
     RowBox[{"ToWord", " ", "/@", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"ToExpression", "/@", 
         RowBox[{"data", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}]}], ")"}], "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "2"}], "]"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"words", "=", 
       RowBox[{"ToWord", " ", "/@", 
        RowBox[{"ToExpression", "/@", 
         RowBox[{"data", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}]}]}]}], ";"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"homflypt", "=", 
     RowBox[{"ToExpression", "/@", 
      RowBox[{"data", "[", 
       RowBox[{"[", 
        RowBox[{"All", ",", "3"}], "]"}], "]"}]}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"time", "=", 
     RowBox[{
      RowBox[{"AbsoluteTiming", "[", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{"\"\<Computing links \>\"", "<>", 
          RowBox[{"ToString", "[", "from", "]"}], "<>", "\"\< to \>\"", " ", "<>",
           " ", 
          RowBox[{"ToString", "[", "to", "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"LaunchKernels", "[", "kernels", "]"}], ";", 
        RowBox[{"jula", "=", 
         RowBox[{"ParallelMap", "[", 
          RowBox[{"Invariant", ",", "words", ",", 
           RowBox[{"Method", "\[Rule]", "\"\<FinestGrained\>\""}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"CloseKernels", "[", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"diff", "=", 
         RowBox[{"Simplify", " ", "/@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"ReplaceAll", "[", 
             RowBox[{"jula", ",", 
              RowBox[{"F", "\[Rule]", "1"}]}], "]"}], "-", 
            RowBox[{"ReplaceAll", "[", 
             RowBox[{"homflypt", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"v", "\[Rule]", 
                 RowBox[{"Sqrt", "[", "\[Lambda]", "]"}]}], ",", 
                RowBox[{"z", "\[Rule]", " ", 
                 RowBox[{"(", 
                  RowBox[{"q", "-", 
                   RowBox[{"q", "^", 
                    RowBox[{"(", 
                    RowBox[{"-", "1"}], ")"}]}]}], ")"}]}]}], "}"}]}], 
             "]"}]}], ")"}]}]}], ";"}], "\[IndentingNewLine]", "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"stream", " ", "=", 
     RowBox[{"OpenAppend", "[", "filename", "]"}]}], ";", "\n", 
    RowBox[{"Export", "[", 
     RowBox[{"stream", ",", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{"knots", ",", "jula", ",", "diff"}], "}"}], "]"}], ",", 
      "\"\<CSV\>\""}], "]"}], ";", "\n", 
    RowBox[{"WriteString", "[", 
     RowBox[{"stream", ",", "\"\<\\n\>\""}], "]"}], ";", "\n", 
    RowBox[{"Close", "[", "stream", "]"}], ";", "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"streamT", "=", 
     RowBox[{"OpenAppend", "[", "\"\<time.csv\>\"", "]"}]}], ";", 
    "\[IndentingNewLine]", 
    RowBox[{"WriteString", "[", 
     RowBox[{"streamT", ",", 
      RowBox[{
       RowBox[{"ToString", "[", "time", "]"}], "<>", "\"\<\\n\>\""}]}], "]"}],
     ";", "\[IndentingNewLine]", 
    RowBox[{"Close", "[", "streamT", "]"}], ";"}]}], "\[IndentingNewLine]", 
  "]"}]}], "Input",
 CellChangeTimes->{{3.634809126816*^9, 3.6348091372080803`*^9}, {
   3.6348093375870028`*^9, 3.6348093683810997`*^9}, {3.634809405146741*^9, 
   3.634809445419197*^9}, {3.634809487264676*^9, 3.634809488095224*^9}, {
   3.634809554007275*^9, 3.634809639002316*^9}, {3.634809674003296*^9, 
   3.634809772173975*^9}, {3.634809804828988*^9, 3.634809912459437*^9}, {
   3.6348100568977203`*^9, 3.6348101161015673`*^9}, {3.6348101464898443`*^9, 
   3.634810170204452*^9}, {3.634810238115926*^9, 3.6348102390876904`*^9}, {
   3.634811482759129*^9, 3.634811493134707*^9}, 3.634815800659321*^9, {
   3.6348158439626493`*^9, 3.6348158461746807`*^9}, {3.634816871984877*^9, 
   3.634816873646328*^9}, {3.634816921987838*^9, 3.634816929932198*^9}, {
   3.634816968878804*^9, 3.6348169733626127`*^9}, {3.6348170278281927`*^9, 
   3.634817061440618*^9}, {3.634817122650559*^9, 3.6348171242511177`*^9}, {
   3.634817199984725*^9, 3.634817236545504*^9}, 3.634822231686035*^9, {
   3.6348222905961175`*^9, 3.634822369011227*^9}, {3.6348224120612874`*^9, 
   3.6348224152962923`*^9}, {3.6348224547463474`*^9, 3.634822796866826*^9}, {
   3.6348229379760237`*^9, 3.6348229385210247`*^9}, 3.6348232544424667`*^9, {
   3.6348232975575275`*^9, 3.634823358597613*^9}, {3.6348235727999125`*^9, 
   3.6348235762799177`*^9}, {3.634824452131144*^9, 3.6348244740561743`*^9}, {
   3.634825174362155*^9, 3.634825175227156*^9}, {3.6348254061524796`*^9, 
   3.6348254582075524`*^9}, {3.6348257988630295`*^9, 
   3.6348258193030577`*^9}, {3.634826244098653*^9, 3.6348262912487187`*^9}, {
   3.6348264578639517`*^9, 3.6348264604489555`*^9}, {3.6348265283440504`*^9, 
   3.634826534364059*^9}, 3.634826575774117*^9, {3.634826671699251*^9, 
   3.6348269153945923`*^9}, {3.6348269887296953`*^9, 3.634827065549803*^9}, {
   3.6348273330781775`*^9, 3.6348274382323275`*^9}, {3.634827469049371*^9, 
   3.6348275702945127`*^9}, {3.6348282909297285`*^9, 3.634828296049736*^9}, {
   3.634829127916902*^9, 3.634829152041936*^9}, {3.6348815477313576`*^9, 
   3.6348815521149654`*^9}, {3.634881595919842*^9, 3.6348816818603926`*^9}, {
   3.6348817315776806`*^9, 3.634881757598526*^9}, {3.6348818762689342`*^9, 
   3.63488190789019*^9}, {3.6348819809451184`*^9, 3.6348819975903473`*^9}, {
   3.634882184245675*^9, 3.634882219080537*^9}, 3.6348822620758123`*^9, {
   3.634882606898218*^9, 3.634882608645421*^9}, {3.634882675320938*^9, 
   3.6348826755705385`*^9}, {3.6348827154130087`*^9, 
   3.6348827156158094`*^9}, {3.634882821539995*^9, 3.6348828221483965`*^9}, {
   3.6348828778414946`*^9, 3.634882898511531*^9}, {3.6348829629718437`*^9, 
   3.6348829912078934`*^9}, {3.6348908141610317`*^9, 
   3.6348908197146416`*^9}, {3.6348976369256163`*^9, 3.634897644304429*^9}, {
   3.634897968353405*^9, 3.6348979714422107`*^9}, {3.6393889126306763`*^9, 
   3.6393889130441227`*^9}, {3.639388963294685*^9, 3.6393889677905397`*^9}, {
   3.639389048691592*^9, 3.639389089360188*^9}, 3.639389136537735*^9, {
   3.63938929053057*^9, 3.639389291250691*^9}, {3.639389326165492*^9, 
   3.639389340067453*^9}, {3.639395044853753*^9, 3.639395047248335*^9}, {
   3.639421357518849*^9, 3.639421421236586*^9}, {3.639421982946165*^9, 
   3.6394219919086018`*^9}, {3.639422087056004*^9, 3.639422087531899*^9}, {
   3.6394225163692408`*^9, 3.6394225662177677`*^9}, {3.639422619159566*^9, 
   3.639422621604198*^9}, {3.639482858947891*^9, 3.639482859409514*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Computing links 154 to 161\"\>"], "Print",
 CellChangeTimes->{{3.63942143450974*^9, 3.639421461105555*^9}, {
   3.639422074017496*^9, 3.639422093173476*^9}, 3.639422225824115*^9, 
   3.639422747150083*^9, 3.6394828779801073`*^9}],

Cell[BoxData["\<\"Computing links 162 to 169\"\>"], "Print",
 CellChangeTimes->{{3.63942143450974*^9, 3.639421461105555*^9}, {
   3.639422074017496*^9, 3.639422093173476*^9}, 3.639422225824115*^9, 
   3.639422747150083*^9, 3.639484210188397*^9}],

Cell[BoxData["\<\"Computing links 170 to 177\"\>"], "Print",
 CellChangeTimes->{{3.63942143450974*^9, 3.639421461105555*^9}, {
   3.639422074017496*^9, 3.639422093173476*^9}, 3.639422225824115*^9, 
   3.639422747150083*^9, 3.639496491612259*^9}],

Cell[BoxData["\<\"Computing links 178 to 179\"\>"], "Print",
 CellChangeTimes->{{3.63942143450974*^9, 3.639421461105555*^9}, {
   3.639422074017496*^9, 3.639422093173476*^9}, 3.639422225824115*^9, 
   3.639422747150083*^9, 3.639496922438528*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{733, 823},
WindowMargins->{{Automatic, 54}, {Automatic, 46}},
FrontEndVersion->"10.0 for Linux x86 (64-bit) (June 27, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[557, 20, 1183, 32, 144, "Input"],
Cell[CellGroupData[{
Cell[1765, 56, 9332, 202, 1001, "Input"],
Cell[CellGroupData[{
Cell[11122, 262, 247, 3, 23, "Print"],
Cell[11372, 267, 245, 3, 23, "Print"],
Cell[11620, 272, 245, 3, 23, "Print"],
Cell[11868, 277, 245, 3, 23, "Print"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
